//slideshowJS v3.0
//------------------------------------------------------
//　ユーザー設定部
//　スライドショー毎のタイトル、コメントはcomment.jsで設定
//------------------------------------------------------

//画像切替え時間初期値3秒：これを変えた場合「slideshowjs.html」も変更必要。
var delay = 3000; 

//画像フェード用設定
//フェードオフにした場合、Netscapeで画像が表示されてからセンタリングされる場合があります。
var fade = true; //フェード true:オン、false：オフ
var speed = 33; //フェードスピード。→大：フェードが遅くなる。spped/1000秒
var change = 15; //フェードステップ量。この値を大きくするとフェードが粗くなる。

//スライド部品画像のディレクトリ
//slideshowjs.htmlからみたディレクトリのパスを記述
var partsDir = "../parts/"; 

//------------------↓ 以下は変更不要 ↓------------------
//--------------------------
//　ブラウザCaminoを判定
//--------------------------
var bw = navigator.userAgent;
var ckCamino = bw.indexOf("Camino");
var ckIE = bw.indexOf("msie");

//----------------------
//　オブジェクトID取得
//----------------------
var doc = document;
var sTitle = doc.getElementById("slidetitle");
var count = doc.getElementById("cnt");
var comment = doc.getElementById("comm");
var sForm = doc.getElementById("slideform");
var dTime = doc.getElementById("delayTime");
var sFade = doc.getElementById("fadein");
var prvBtn = doc.getElementById("prvBtn");
var autoBtn = doc.getElementById("autoBtn");
var stopBtn = doc.getElementById("stopBtn");
var nxtBtn = doc.getElementById("nxtBtn");
var help = doc.getElementById("help");

sForm.reset();
sTitle.innerHTML = slideTitle; //スライドショータイトルを表示
//--------------------
//　各変数初期値設定
//--------------------
var timerID,no,delay,autoID,visiID;
var autoState = false; //オートスライドショー稼働状況ステータス
var helpState = false; //ヘルプ表示・非表示ステータス

//-------------------------------------
//　ロールオーバー用ナビ画像キャッシュ
//-------------------------------------
var PRV = new Array();
var START = new Array();
var STOP = new Array();
var NXT = new Array();
var PUS = new Array();
for(var i=1;i<3;i++){ 
	PRV[i] = new Image(); PRV[i].src = partsDir + "prv" + i + ".gif"; 
	START[i] = new Image(); START[i].src = partsDir + "start" + i + ".gif";
	STOP[i] = new Image(); STOP[i].src = partsDir + "stop" + i + ".gif";
	NXT[i] = new Image(); NXT[i].src = partsDir + "nxt" + i + ".gif";
	PUS[i] = new Image(); PUS[i].src = partsDir + "pause" + i + ".gif";
}

//--------------------------
//　ナビ画像ロールオーバー
//--------------------------
function chgImg(btn,num){
	if(btn=="prv") {
		prvBtn.src = PRV[num].src;
	} else if(btn=="start"){
		autoBtn.src = START[num].src;
	} else if(btn=="stop"){
		stopBtn.src = STOP[num].src;
	} else if(btn=="nxt"){
		nxtBtn.src = NXT[num].src;
	} else if(btn=="pus"){
		autoBtn.src = PUS[num].src;
	}
}


//---------------------
//　オブジェクト定義
//---------------------
var SLIDEobj = function(obj,id){
	this._element  = doc.getElementById(id);
	this._style = this._element.style;
	this._obj = obj;
	this._imgLoading = false; //画像読込み状況
}

//--------------------
//　オブジェクト生成
//--------------------
var Photoobj = new SLIDEobj("Photoobj","slideImg");
var Loadobj = new SLIDEobj("Loadobj","loader");

//--------------------------
//　オブジェクト表示関連
//--------------------------
SLIDEobj.prototype.show = function(){ this._style.visibility = "visible"; }
SLIDEobj.prototype.hide = function(){ this._style.visibility = "hidden"; }

//--------------------
//　フェードイン処理
//--------------------
SLIDEobj.prototype.setOpacity = function(opacity){ 
	opacity = (opacity == 100)?99.999:opacity;
	this._style.filter = "alpha(opacity=" + opacity + ")";
	this._style.MozOpacity = opacity/100;
	this._style.opacity = opacity/100;
}

SLIDEobj.prototype.fadeIn = function(opacity, change, speed){ 
	if (opacity <= 100){
		this.setOpacity(opacity);
		opacity += change;
		setTimeout(this._obj + ".fadeIn(" + opacity + "," + change + "," + speed + ")", speed);
	} else {
		this.setOpacity(100);
		Photoobj._imgLoading = false;
	}
}

//----------------------------
//　画像切替え時、画像非表示
//----------------------------
function objHide(){
	Photoobj._imgLoading = true;
	Photoobj.hide();
}


//------------------------------
//　画像表示と画像サイズの取得
//------------------------------
SLIDEobj.prototype.setImg = function(num){
	this._element.onload = function(){
		Photoobj._style.top = 211-(Photoobj._element.height/2) + "px";
		Photoobj._style.left = 211-(Photoobj._element.width/2) + "px";
		Loadobj.hide();
		Photoobj.show();
		if(fade == true){ 
			Photoobj.fadeIn(0,change,speed); 
		} else {
			Photoobj._imgLoading = false;
		}
	}
	if(num<10){ num = "0" + num; }
	this._element.src = imageDir + num + ".jpg";
}

//------------------------------
//　画像カウンタ・コメント更新
//------------------------------
function setCombox(imgno){
	count.innerHTML = imgno + "/" + totalno;
	comment.innerHTML = COMS[imgno-1];
}

//--------------------------
//　画像表示用タイマー起動
//--------------------------
function setTimer(imgno){
	Loadobj.show();
	setCombox(imgno);
	timerID = setTimeout("Photoobj.setImg("+imgno+")",125);
}

//---------------------
//　オートボタン変更
//---------------------
//スタートボタンを押すとポーズボタンに変わり、ポーズボタンを押すとスタートボタンに変わる
//またマウスオーバーでの画像切替え部分もボタン変更に対応させる
function setButton(){
	if(autoState == true){ 
		autoBtn.src = PUS[1].src;
		if(ckIE > -1){ //IE用
			autoBtn.setAttribute("onmouseover",new Function("chgImg('pus',2);"));
			autoBtn.setAttribute("onmouseout",new Function("chgImg('pus',1);"));
		} else {
			autoBtn.setAttribute("onmouseover","chgImg('pus',2);");
			autoBtn.setAttribute("onmouseout","chgImg('pus',1);");
		}
	} else if(autoState == false){
		autoBtn.src = START[1].src;
		if(ckIE > -1){ //IE用
			autoBtn.setAttribute("onmouseover",new Function("chgImg('start',2);"));
			autoBtn.setAttribute("onmouseout",new Function("chgImg('start',1);"));
		} else {
			autoBtn.setAttribute("onmouseover","chgImg('start',2);");
			autoBtn.setAttribute("onmouseout","chgImg('start',1);");
		}
	}
}


//-----------------------
//　画像切替え時間設定
//-----------------------
function setDelay(){
	if(autoState == true){
		clearInterval(autoID); //setIntervalを停止し、新しい画像切替え時間を設定
		delay = dTime.options[dTime.selectedIndex].value;
		autoID = setInterval("next()",delay); //再びsetIntervalを再開
	} else if(autoState == false){
		delay = dTime.options[dTime.selectedIndex].value;
	}

	//セレクトメニューからフォーカスを外す。
	//フォーカスしたままだとカーソルキーに反応してメニュー値が動いてしまうため。
	dTime.blur(); 
	if(ckCamino > -1){ //Caminoでblur()が効かないため、セレクトメニューを一度非表示にしてフォーカスから外す
		dTime.style.visibility = "hidden";
		visiID = setTimeout("doVisible()",1);
	}
}

function doVisible(){
	dTime.style.visibility = "visible";
	clearTimeout(visiID);
}


//------------
//　画像送り
//------------
function next(){
	if(Photoobj._imgLoading == false){
		objHide();
		if (no == totalno) { //最後の画像が表示されたら最初の画像を表示し停止
			if(autoState == true){ setSlide(); }
			no = 1; 
		} else { 
			no++; 
		}
		setTimer(no);
	}
}

function prev(){
	if(Photoobj._imgLoading == false){
		objHide();
		if (no == 1) { no = totalno; } else { no--; }
		setTimer(no);
	}
}

//-------------------------
//　オートスライドショー
//-------------------------
function setAuto(){ 
	if(autoState == false){
		autoState = true;
		autoID = setInterval("next()",delay);
		setButton();
	} else if(autoState == true){
		pause();
	}
}

//--------------------------------
//　オートスライドショー一時停止
//--------------------------------
function pause(){
	if(autoState == true){
		clearInterval(autoID);
		autoState = false;
		setButton();
	}
}

//---------------------------------------------------
//　カーソルキーでprev,nextに振り分け、ESCでクローズ
//---------------------------------------------------
doc.onkeyup = function(evt){
	if(Photoobj._imgLoading == false){
		var kc = (window.event) ? window.event.keyCode : evt.keyCode;
		if(kc == 39){ //右→カーソル(次画像へ)
			Photoobj.hide();
			pause();
			next();
		} else if(kc == 37){ //左←カーソル(前画像へ)
			Photoobj.hide();
			pause();
			prev();
		} else if(kc == 38){ //上↑カーソル(オートスライドショー開始/一時停止)
			setAuto();
		} else if(kc == 40){ //下↓カーソル(ストップ。スライドショーをリセットする)
			setSlide();
		}
	}
	return false; //safariではキーの動作が2回発生してしまう問題の対策
}

//-----------------------
//　ヘルプ表示・非表示
//-----------------------
function showHelp(){
	if(helpState==false){
		help.style.display = "block";
		helpState = true
	} else if(helpState==true){
		help.style.display = "none";
		helpState = false;
	}
}

//--------------------------
//　スライドショー初期表示
//--------------------------
function setSlide(){
	pause();
	no = 1;
	objHide();
	Photoobj._style.border = "1px solid #ccc";
	setTimer(1);
}
